-- 每日答题场景界面
checkRequire("Lua_AnswerLeftInfoPanel"); -- 每日答题左侧栏信息面板
checkRequire("Lua_AnswerStartEndPanel"); -- 每日答题开始结束tips
checkRequire("Lua_AnswerQuestionPanel"); -- 每日答题题目
checkRequire("Lua_AnswerResultPanel"); -- 每日答题结果
Lua_AnswerQustionInfoWindow = class("Lua_AnswerQustionInfoWindow", Lua_FullSizeWindow);
function Lua_AnswerQustionInfoWindow:ctor()
	self:superCall("ctor", false, false, 500, false, false, false);
	
	self.windowName = "Lua_AnswerQustionInfoWindow";
end

function Lua_AnswerQustionInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.hook:stop(true);

	self.leftInfoPanel = Lua_AnswerLeftInfoPanel.new(self.content);
	self.leftInfoPanel:setLocation(-MainWinDefine.V_width / 2 + 640, 0);

	self:addLuaEvent("rOwnerAnswerInfo", self, self.onOwnerAnswerInfo);
	self:addLuaEvent("rAnswerEndInfo", self, self.onAnswerEndInfo);
	self:addLuaEvent("rAnswerInfoUpdate", self, self.onQuestionInfoUpdate);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onExitAnswer);
	-- self:addCSharpEvent("CheckJump", self, self.onCheckPlayerSelect);
	self:onQuestionInfoUpdate();
	-- self:onAnswerEndInfo();
	Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sOwnerAnswerInfo();

	self:addTimer("checkScene", 1, self, self.onCheckScene);
end

function Lua_AnswerQustionInfoWindow:onCheckScene()
	local sceneId = DataCenter.roleData.sceneId;
	local sceneData = Lua_SceneConfigData.getSceneConfig(sceneId);
	local curOpenWin = sceneData.config.open_win;
	local isShowWin = false;
	if curOpenWin ~= nil then
		for i,v in ipairs(curOpenWin) do
			if v == "Lua_AnswerQustionInfoWindow" then
				isShowWin = true;
				break;
			end
		end
	end
	if isShowWin == false then
		self:hide();
	end
end

function Lua_AnswerQustionInfoWindow:onOwnerAnswerInfo(sucIdx)
	if self.leftInfoPanel ~= nil then
		self.leftInfoPanel:updateAnswerInfo();
	end

	-- 开始
	local num = Mathf.Round(DataCenter.answerData.answerWaitTime - (getTime() - DataCenter.answerData.getOwnAnswerInfoTime));
	if num > 0 and DataCenter.answerData.answerWaitTime > 0 then
		if self.answerEndPanel ~= nil then
			self.answerEndPanel:dispose();
			self.answerEndPanel = nil;
		end

		if self.answerStartPanel == nil then
			self.answerStartPanel = Lua_AnswerStartEndPanel.new(self.content, true);
		end
		self.answerStartPanel:updateTimeTips(num);
	else
		if self.answerStartPanel ~= nil then
			self.answerStartPanel:dispose();
			self.answerStartPanel = nil;
		end
	end

	-- 回答成功失败 答题情况，0表示没有，1表示对，2表示错
	if sucIdx == 1 then
		OperateAlert.show(LanUtil.getValue(121814));

		if self.answerEff == nil then
			self.answerEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_huidazhengque", "gui_huidazhengque", 0, 0);
		else
			self.answerEff:setUrl("/effects/scsEffects/gui_huidazhengque", "gui_huidazhengque");
		end
	elseif sucIdx == 2 then
		OperateAlert.show(LanUtil.getValue(121815));

		if self.answerEff == nil then
			self.answerEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_huidacuowu", "gui_huidacuowu", 0, 0);
		else
			self.answerEff:setUrl("/effects/scsEffects/gui_huidacuowu", "gui_huidacuowu");
		end
	end
end

-- 结束
function Lua_AnswerQustionInfoWindow:onAnswerEndInfo()
	-- 第一名
	local str = DataCenter.answerData.answerFirstName;
	if str ~= nil and str ~= "" then
		if self.resultPanel == nil then
			self.resultPanel = Lua_AnswerResultPanel.new(self.content);
		end
		self.resultPanel:updateShowResult(str);
	else
		if self.resultPanel ~= nil then
			self.resultPanel:dispose();
			self.resultPanel = nil;
		end
	end

	-- 剩余时间
	-- local num = Mathf.Round(DataCenter.answerData.answerExitLeftTime - (getTime() - DataCenter.answerData.getExitInfoTime));
	-- if DataCenter.answerData.answerExitLeftTime > 0 and num > 0 then
	local num = DataCenter.answerUtil.forcePlayerExitTimes;
	if num ~= nil and num > 0 then
		if self.questionPanel ~= nil then
			self.questionPanel:dispose();
			self.questionPanel = nil;
		end

		if self.answerStartPanel ~= nil then
			self.answerStartPanel:dispose();
			self.answerStartPanel = nil;
		end

		if self.answerEndPanel == nil then
			self.answerEndPanel = Lua_AnswerStartEndPanel.new(self.content, false);
		end
		self.answerEndPanel:updateTimeTips(num);
	else
		if self.answerEndPanel ~= nil then
			self.answerEndPanel:dispose();
			self.answerEndPanel = nil;
		end
	end
end

-- 问题更新
function Lua_AnswerQustionInfoWindow:onQuestionInfoUpdate()
	local idx = DataCenter.answerData.questionIndex;
	local desc = DataCenter.answerData.questionDesc;
	if idx > 0 and desc ~= nil and desc ~= "" then
		if self.answerStartPanel ~= nil then
			self.answerStartPanel:dispose();
			self.answerStartPanel = nil;
		end

		if self.questionPanel == nil then
			self.questionPanel = Lua_AnswerQuestionPanel.new(self.content);
		end
		self.questionPanel:updateShowQuestion();
	else
		if self.questionPanel ~= nil then
			self.questionPanel:dispose();
			self.questionPanel = nil;
		end
	end
end

function Lua_AnswerQustionInfoWindow:onExitAnswer()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(121820), type = 1, subFun = self.onOutClick});
end

function Lua_AnswerQustionInfoWindow:onOutClick()
	Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sExitScene();
end

-- 玩家位置更新
function Lua_AnswerQustionInfoWindow:onCheckPlayerSelect()
	if self.questionPanel ~= nil then
		self.questionPanel:updateOwnSelect();
	end
end

function Lua_AnswerQustionInfoWindow:dispose()
	if self.leftInfoPanel ~= nil then
		self.leftInfoPanel:dispose();
		self.leftInfoPanel = nil;
	end
	if self.answerStartPanel ~= nil then
		self.answerStartPanel:dispose();
		self.answerStartPanel = nil;
	end
	if self.resultPanel ~= nil then
		self.resultPanel:dispose();
		self.resultPanel = nil;
	end
	if self.answerEndPanel ~= nil then
		self.answerEndPanel:dispose();
		self.answerEndPanel = nil;
	end
	if self.questionPanel ~= nil then
		self.questionPanel:dispose();
		self.questionPanel = nil;
	end
	if self.answerEff ~= nil then
		self.answerEff:dispose();
		self.answerEff = nil;
	end

	self:superCall("dispose");
end