-- 每日答题入口
Lua_EveryDayAnswerWindow = class("Lua_EveryDayAnswerWindow", Lua_SecondSizeWindow)
function Lua_EveryDayAnswerWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EveryDayAnswerWindow";
	self.skinName = "EveryDayAnswerWindow_skin";
	self.titleText = LanUtil.getValue(121800);
end

function Lua_EveryDayAnswerWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.descBg.imgTypeNum = 4;
	self.descBg.widget.border = Vector4(0, 10, 0, 10);

	local info = DataCenter.xianshiData:getDataById(getConfig({"answer_const", "activity_id", "value"}));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121801), info.openTimeDesc);
	self.descTxt.text = LanUtil.getValue(121802);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(90, 90, 9);
	self.rItem:setMaxShow(9);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(1, 1);
	self.rItem:setLocation(304, -155, 0);
	self.rItem:setRewardByRewardList(Array(info.display_reward));

	self.tipsLab.clickScale = false;
	self.tipsLab.text = LanUtil.getValue(121823);
	self.tipsLab:addClickFuntion(self, self.onHelp);
	self.tipsIcon:addClickFuntion(self, self.onHelp);

	self.enterBtn.label = LanUtil.getValue(121803);
	self.enterBtn:addClickFuntion(self, self.onEnterBtnClick);
end

function Lua_EveryDayAnswerWindow:onHelp(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(121824));
end

function Lua_EveryDayAnswerWindow:onEnterBtnClick(go)
	if DataCenter.roleData.sceneId == 40401 then -- 答题场景(注意场景id写死，配置修改的时候也得改)
		OperateAlert.show(LanUtil.getValue(121805));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sEnterAnswerScene(); -- 进入场景
end

function Lua_EveryDayAnswerWindow:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose ();
		self.rItem = nil;
	end
    self:superCall("dispose");
end