-- 答题开始结束界面
Lua_AnswerStartEndPanel = class("Lua_AnswerStartEndPanel", Lua_DisplayObject);
function Lua_AnswerStartEndPanel:ctor(p, isStart)
	self.isStart = isStart == nil and false or isStart;
	self:superCall("ctor", p, "AnswerStartEndPanel_skin");
end

function Lua_AnswerStartEndPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.timeNum = Lua_NumberImage.new(self.content);
	self.timeNum.pivot = 2;
	self.timeNum.prefix = "ui_fuben_";
	self.timeNum.numWidth = 22;
	self.timeNum.num = 22;
	self.timeNum:setDepth(3);
	self.timeNum:setNumScale(0.9, 0.9);

	if self.isStart then
		self.startObj:SetActive(true);
		self.endObj:SetActive(false);
	else
		self.startObj:SetActive(false);
		self.endObj:SetActive(true);
	end
end

function Lua_AnswerStartEndPanel:updateTimeTips(num)
	if num > 0 then
		self.timeNum.num = num;
		if self.isStart then
			self.timeNum:setLocation(-66, 154.5);
		else
			self.timeNum:setLocation(4, 110.5);
		end

    	self.endTime = num;
    	if self.bRegisterEndTime ~= true then
    		self.bRegisterEndTime = true;
    		Lua_CommonUtil.addTimer("Lua_AnswerStartEndPanel", 1, self, self.updateAnswerEndTime);
    	end
    else
    	self:clearEndTimer();
		return;
    end
end

function Lua_AnswerStartEndPanel:updateAnswerEndTime()
	self.endTime = self.endTime - 1;
	self.timeNum.num = self.endTime;
	if self.endTime <= 0 then
		self.endTime = 0;
		self:clearEndTimer();
		if self.isStart == false then -- 强制玩家退出
			Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sExitScene();
		end
		return;
	end
end

function Lua_AnswerStartEndPanel:clearEndTimer()
	if self.bRegisterEndTime == true then
		self.bRegisterEndTime = false;
		Lua_CommonUtil.removeTimer(self, self.updateAnswerEndTime);
	end
end

function Lua_AnswerStartEndPanel:dispose()
	if self.timeNum ~= nil then
		self.timeNum:dispose();
		self.timeNum = nil;
	end

	self:clearEndTimer();
	self:superCall("dispose");
end